<?php
// WizyTówka 4
if (!defined('WT')) exit();


if ( $_SERVER['REQUEST_METHOD'] == 'POST' ) {

	// przywracanie z pliku kopii zapasowej

	if ( isset($_GET['przywracanie']) and isset($_POST['plikArchiwumKopii'])
		and !odczytKonf('wysokieZabezpieczenie') ) {

		$tymczZIP = '_' . time();

		// otwieranie pliku ZIP kopii zapasowej
		$paczkaZIP = new ZipArchive;
		$paczkaZIP -> open( odczytKonf('adresPlikow') . '/' . $_POST['plikArchiwumKopii'] );

		if ( $paczkaZIP->status == ZipArchive::ER_OK and $paczkaZIP -> extractTo( $tymczZIP ) ) {

			$paczkaZIP -> close();

			// minimalne wymagania do przywrócenia z pliku archiwum
			if ( !file_exists( $tymczZIP . '/strony' ) or !file_exists( $tymczZIP . '/szkice' )
				or !file_exists( $tymczZIP . '/wtk' ) ) {
				komunikat('zle.Wybrana kopia zapasowa jest niekompletna i nie można jej przywrócić.');
				$usunTegoBrzydkiegoZIPa = true;
			}

			else {

				// usunięcie pliku ZIP kopii zapasowej
				unlink( odczytKonf('adresPlikow') . '/' . $_POST['plikArchiwumKopii'] );

				// inne brakujące foldery
				$inneFoldery = array( 'pliki', 'motywy', 'typy' );
				foreach ( $inneFoldery as $folder ) {
					if ( !file_exists( $tymczZIP . '/' . $folder ) )
						mkdir( $tymczZIP . '/' . $folder );
				}

				// zamiana folderu DANE i folderu kopii zapasowej
				rename( DANE, '.dane_' . date('Y-m-d-H-i-s') );
				rename( $tymczZIP, DANE );

				komunikat('dob.Kopia zapasowa została przywrócona.');
				$kopiaZapasowaPrzywrocona = true;

			}

		}

		else {
			komunikat('zle.Wystąpił błąd podczas otwierania pliku ZIP.');
			$paczkaZIP -> close();
			$usunTegoBrzydkiegoZIPa = true;
		}

		if ( isset($usunTegoBrzydkiegoZIPa) ) {
			function usunRekurencyjnie( $doUsuniecia ) {
				if ( is_dir($doUsuniecia) ) {
					foreach ( glob( $doUsuniecia . '/*' ) as $plik )
						usunRekurencyjnie($plik);
					rmdir($doUsuniecia);
				}
				else
					unlink($doUsuniecia);
			}
			usunRekurencyjnie( $tymczZIP );
		}

	}


	// tworzenie pliku kopii zapasowej

	elseif ( isset($_POST['stronyISzkice']) or isset($_POST['konfiguracja']) or isset($_POST['wyslanePliki'])
			or isset($_POST['motywy']) or isset($_POST['typy']) ) {

		$plikiPaczki = array();

		// zawartość folderu DANE
		if ( isset($_POST['konfiguracja']) ) {
			$plikiDANE = plikiFolderu( DANE, false, false );
			foreach ( $plikiDANE as $plik ) {
				if ( !is_dir( DANE . '/' . $plik ) )
					$plikiPaczki[] = $plik;
			}
		}

		// lista podfolderów folderu DANE do umieszczenia w archiwum ZIP
		$listaPodfolderow = array();
		if ( isset($_POST['konfiguracja']) )    $listaPodfolderow[] = 'wtk';
		if ( isset($_POST['motywy']) )          $listaPodfolderow[] = 'motywy';
		if ( isset($_POST['typy']) )            $listaPodfolderow[] = 'typy';
		if ( isset($_POST['stronyISzkice']) ) { $listaPodfolderow[] = 'strony'; $listaPodfolderow[] = 'szkice'; }
		if ( isset($_POST['wyslanePliki']) and
			substr( odczytKonf('adresPlikow'), 0, strlen(DANE) ) == DANE)
			$listaPodfolderow[] = substr( odczytKonf('adresPlikow'), strlen(DANE)+1 );

		// pętelka po wszystkich elementach możliwych do umieszczenia w pliku archiwum ZIP
		foreach ( $listaPodfolderow as $podfolder ) {
			$plikiPodfolderu = plikiFolderu( DANE . '/' . $podfolder );
			foreach ( $plikiPodfolderu as $plik )
				$plikiPaczki[] = $podfolder . '/' . $plik;
		}

		// stworzenie paczki ZIP
		$czasUniksowy = time();
		$nazwaPaczkiZIP = odczytKonf('adresPlikow') . '/kopia_' . date('Y-m-d-H-i-s',$czasUniksowy) . '.zip';
		$paczkaZIP = new ZipArchive;
		$paczkaZIP -> open( $nazwaPaczkiZIP, ZIPARCHIVE::CREATE );

		if ( $paczkaZIP->status == ZipArchive::ER_OK ) {

			zapisKonf( array( 'kopiaZapasowaOstatnia' => $czasUniksowy ) );

			// stworzenie folderów w paczce ZIP
			foreach ( $listaPodfolderow as $podfolder )
				$paczkaZIP -> addEmptyDir($podfolder);

			// dodanie plików do paczki
			
			foreach ( $plikiPaczki as $plik )
				$paczkaZIP -> addFile( DANE . '/' . $plik, $plik );

			komunikat('dob.Plik archiwum kopii zapasowej został wygenerowany.');
			$kopiaZapasowaWygenerowana = true;
			header( 'Refresh: 1; url=' . $nazwaPaczkiZIP );

		}

		else {
			komunikat('zle.Wystąpił błąd podczas generowania pliku ZIP.');
			if ( file_exists( $nazwaPaczkiZIP ) )
				unlink( $nazwaPaczkiZIP );
		}

		$paczkaZIP -> close();

	}

	// usuwanie pliku kopii zapasowej

	elseif ( isset($_POST['usunPlikArchiwum']) and
		   file_exists( odczytKonf('adresPlikow') . '/kopia_' . date( 'Y-m-d-H-i-s', odczytKonf('kopiaZapasowaOstatnia') ) . '.zip' ) ) {

		if ( unlink( odczytKonf('adresPlikow') . '/kopia_' . date( 'Y-m-d-H-i-s', odczytKonf('kopiaZapasowaOstatnia') ) . '.zip' ) )
			komunikat('dob.Plik archiwum kopii zapasowej został usunięty z serwera.');

		else
			komunikat('zle.Plik archiwum kopii zapasowej nie został usunięty z serwera. Usuń go samodzielnie.');

	}

}

if ( isset($kopiaZapasowaPrzywrocona) )
	$CHOWAC_SIE_KTO_MOZE = 1;

include (SYSTEM.'/admin/naglowek.php');
?>
<h2>Kopia zapasowa</h2>

<form method="post">

<?php
if ( isset($kopiaZapasowaPrzywrocona) ) {
?>

<p>Wszystkie ustawienia oraz dotychczasowa zawartość witryny (wysłane pliki, strony i szkice stron) zostały zastąpione zawartością pliku kopii zapasowej.</p>

<p>Dotychczasowa zawartość strony nadal jest przechowywana na serwerze w katalogu <code><?php echo '.dane_' , date('Y-m-d-H-i-s') ?></code>. Istnieje możliwość jej przywrócenia przy uzyciu klienta FTP.</p>

<p><strong><a href="<?php echo odczytKonf('panelAdminAdres') ?>"><?php echo odczytKonf('adres') , '/' , odczytKonf('panelAdminAdres') ?></a></strong></p>

<p>Kliknij teraz powyższy odnośnik, aby ponownie zalogować się do panelu administracyjnego.</p>

<p class="uwaga">Jeżeli po wygenerowaniu przywróconej właśnie kopii zapasowej dane logowania zostały zmodyfikowane, zaloguj się teraz starym hasłem.</p>

<?php
}
elseif ( isset($kopiaZapasowaWygenerowana) ) {
?>

<h3>Tworzenie kopii zapasowej witryny</h3>

<table>
	<tr> <td>Plik kopii zapasowej:</td> <td><a href="<?php echo $nazwaPaczkiZIP ?>"><?php echo basename($nazwaPaczkiZIP) ?></a></td> </tr>
</table>

<p class="informacja">Kliknij nazwę archiwum ZIP, aby go pobrać. Nie zapomnij usunąć pliku kopii zapasowej bezpośrednio po zakończeniu pobierania go na komputer, korzystając z&nbsp;poniższego przycisku.</p>

<input type="hidden" name="usunPlikArchiwum" value="1" />
<p class="przyciskWysylania"><input type="submit" value="Usuń plik kopii z serwera" /></p>

<?php
}
elseif ( isset($_GET['przywracanie']) and !odczytKonf('wysokieZabezpieczenie') ) {
	// przywrócić można tylko archiwa ZIP
	$listaArchiwowZIP     = listaPlikow('zip');
	$zablokujPrzywracanie = empty($listaArchiwowZIP) ? true : false;
?>

<h3>Przywracanie kopii zapasowej witryny</h3>

<table>
	<tr> <td>Data wygenerowania ostatniej kopii:</td> <td><?php echo (odczytKonf('kopiaZapasowaOstatnia')) ? pokazDate(odczytKonf('kopiaZapasowaOstatnia')) : 'nigdy' ?></td> </tr>
	<tr> <td>Archiwum ZIP kopii:</td> <td><select name="plikArchiwumKopii" <?php wylaczElement($zablokujPrzywracanie) ?>><?php generujListeWyboru($listaArchiwowZIP) ?></select></td> </tr>
</table>

<p class="informacja">Istnieje możliwość przywrócenia kopii wygenerowanej przez system lub stworzonej samodzielnie. Należy wskazać przesłany wcześniej plik archiwum ZIP zawierający zawartość folderu <code><?php echo DANE ?></code> (ale nie sam folder). Nie można przywrócić kopii zapasowej, jeżeli nie zawiera ona co najmniej konfiguracji witryny oraz stron i szkiców stron.</p>

<p class="uwaga">Uwaga! Przywrócenie kopii zapasowej zastąpi całą obecną zawartość strony! Aktualna konfiguracja i&nbsp;zawartość  witryny zostanie zachowana na serwerze w folderze o nazwie zawierającej dzisiejszą datę. Cofnięcie przywrócenia kopii zapasowej będzie możliwie tylko przy użyciu klienta FTP.</p>

<p class="przyciskWysylania"><input type="submit" value="Przywróć kopię zapasową" <?php wylaczElement($zablokujPrzywracanie) ?> /></p>

<?php
}
else {
	// kopia zapasowa nie obejmie własnych typów lub motywów, jeżeli użytkownik z nich nie korzysta
	$zablokujWlasneMotywy = ( plikiFolderu( DANE . '/motywy', true ) == null ) ? true : false;
	$zablokujWlasneTypy   = ( plikiFolderu( DANE . '/typy',   true ) == null ) ? true : false;
	// kopia zapasowa nie obejmie wysłanych plików, jeśli folder plików został zmieniony przez WTK
	$zablokujWyslanePliki = ( odczytKonf('adresPlikow') == DANE . '/pliki' ) ? false : true;
?>

<h3>Tworzenie kopii zapasowej witryny</h3>

<table>
	<tr> <td <?php echo (!$zablokujWlasneMotywy or !$zablokujWlasneTypy) ? 'rowspan="2"' : '' ?>>Wybór kopiowanych elementów:</td>
		<td><input type="checkbox" name="stronyISzkice" value="1" id="op11" checked /><label for="op11">Strony i szkice stron</label></td>
		<td><input type="checkbox" name="konfiguracja" value="1" id="op12" checked /><label for="op12">Konfiguracja witryny</label></td>
		<td><input type="checkbox" name="wyslanePliki" value="1" id="op13" <?php echo ($zablokujWyslanePliki) ? 'disabled' : 'checked' ?> /><label for="op13">Wysłane pliki</label></td>
	</tr>
	<?php if ( !$zablokujWlasneMotywy or !$zablokujWlasneTypy ) { ?>
	<tr>
		<td><input type="checkbox" name="motywy" value="1" id="op14" <?php echo ($zablokujWlasneMotywy) ? 'disabled' : 'checked' ?> /><label for="op14">Motywy</label></td>
		<td><input type="checkbox" name="typy" value="1" id="op15" <?php echo ($zablokujWlasneTypy) ? 'disabled' : 'checked' ?> /><label for="op15">Typy zawartości</label></td>
		<td></td>
	</tr>
	<?php } ?>
</table>

<p class="informacja">Narzędzie kopii zapasowej umożliwia wygenerowanie archiwum ZIP zawierającego kopię całej witryny lub wybranych jej elementów. <?php if ( !odczytKonf('wysokieZabezpieczenie') ) { ?>Aby móc w przyszłości przywrócić kopię zapasową, używając wbudowanej funkcji, musisz umieścić w niej strony i szkice stron oraz konfigurację witryny.<?php } ?></p>

<?php if ( !odczytKonf('wysokieZabezpieczenie') ) { ?>
<h3>Przywracanie kopii zapasowej witryny</h3>

<table>
	<tr> <td>Data wygenerowania ostatniej kopii:</td> <td><?php echo (odczytKonf('kopiaZapasowaOstatnia')) ? pokazDate(odczytKonf('kopiaZapasowaOstatnia')) : 'nigdy' ?></td> </tr>

	<tr> <td>Archiwum ZIP kopii:</td> <td>(<a href="?id=kopiaZapasowa&przywracanie">przywróć kopię zapasową</a>)</td> </tr>
</table>
<?php } ?>

<p class="przyciskWysylania"><input type="submit" value="Stwórz kopię zapasową" /></p>

<?php
}
?>

</form>
<?php
include (SYSTEM.'/admin/stopka.php');