<?php
// WizyTówka 4
if (!defined('WT')) exit();


if ( empty($wtZawartoscStrony) ) {
?>
<p class="wtKomunikat">Do tej galerii zdjęć nie dodano jeszcze żadnego obrazu.</p>
<?php
}

else {

	if ( $wtUstawieniaStrony['sortowanie'] == 'losowo' )
		shuffle( $wtZawartoscStrony );
	else
		$wtZawartoscStrony = sortowanie( $wtZawartoscStrony, $wtUstawieniaStrony['sortowanie'], $wtUstawieniaStrony['sortowanieOdwrotnie'] );

	$skryptGalleria = ($wtUstawieniaStrony['wyswietlanie'] == 'galleria') ? true : false;

	if ( $skryptGalleria ) {
?>
<noscript><p class="wtKomunikat">Galeria zdjęć wymaga włączenia języka JavaScript w przeglądarce..</p></noscript>
<style scoped>
	ul.wtGaleriaZdjec { margin-left: 0; padding-left: 0; margin-right: 0; padding-right: 0; list-style-type: none; }
	ul.wtGaleriaZdjec > li { display: none; }
</style>
<?php
	}
	else {
?>
<style scoped>
	ul.wtGaleriaZdjec { margin-left: 0; padding-left: 0; margin-right: 0; padding-right: 0; list-style-type: none; font: 0 /0 sans-serif; }
	ul.wtGaleriaZdjec li { display: inline-block; overflow: hidden; vertical-align: top; height: <?php echo $wtUstawieniaStrony['miniatury']['wysokoscMiniatury'] ?>px; width: <?php echo floor( 100 / $wtUstawieniaStrony['miniatury']['kolumny'] ) ?>%; }
	ul.wtGaleriaZdjec li span { display: table; width: 100%; height: 100%; }
	ul.wtGaleriaZdjec li span a { display: table-cell; vertical-align: middle; text-align: center; }
	ul.wtGaleriaZdjec li span a img { margin: 0; padding: 0; width: 90% !important; }
</style>
<?php
	}
?>

<ul class="wtGaleriaZdjec">

<?php
	foreach ( $wtZawartoscStrony as $zdjecie ) {

		if ( !file_exists( odczytKonf('adresPlikow') . '/' . $zdjecie['nazwaPliku'] ) )
			continue;

		$adresZdjecia     = odczytKonf('adres') . '/' . odczytKonf('adresPlikow') . '/' . $zdjecie['nazwaPliku'];
		$zdjecie['tytul'] = str_replace( '"', '&quot;', tekst($zdjecie['tytul']) );

		if ( $skryptGalleria and !empty($zdjecie['opis']) )
			$zdjecie['opis'] = str_replace( '"', 'qouot;', ograniczonyHTML(tekst($zdjecie['opis'])) );

		echo '<li>';

		if ( $skryptGalleria )
			echo '<a href="', $adresZdjecia, '"> <img data-title="', $zdjecie['tytul'], '" ', ((!empty($zdjecie['opis'])) ? 'data-description="' . $zdjecie['opis'] . '" ' : ' '), 'src="', $adresZdjecia, '"> </a>';
		else
			echo '<span> <a data-lightbox="galeriaZdjec" title="', $zdjecie['tytul'], '" href="', $adresZdjecia, '"> <img src="', $adresZdjecia, '" alt="', $zdjecie['tytul'], '"> </a> </span>';

		echo '</li>', "\n";

		// ze względu na wymagania skryptu Galleria nie mogę określić alt="" dla <img>,
		// gdyż "alt" nadpisuje opis zdjęcia z "data-description", a opis może być pusty

	}
?>

</ul>

<script>
<?php if ( $skryptGalleria ) { ?>
	Galleria.configure({
		autoplay      : <?php echo ($wtUstawieniaStrony['galleria']['pokazSlajdow']) ? $wtUstawieniaStrony['galleria']['pokazSlajdowCzas'] . '000' : 'false' ?>,
		height        : <?php echo $wtUstawieniaStrony['galleria']['wysokosc'] ?>,
		transition    : '<?php echo $wtUstawieniaStrony['galleria']['animacja'] ?>',
		_toggleInfo   : <?php echo ($wtUstawieniaStrony['galleria']['opis'] == 'zawsze') ? 'false' : 'true' ?>,
		showInfo      : <?php echo ($wtUstawieniaStrony['galleria']['opis'] == 'nigdy') ? 'false' : 'true' ?>,
		imageCrop     : <?php echo ($wtUstawieniaStrony['galleria']['przycinanie'] == '.') ? 'false' : '\''.$wtUstawieniaStrony['galleria']['przycinanie'].'\'' ?>,
		maxScaleRatio : <?php echo ($wtUstawieniaStrony['galleria']['przycinanie'] == '.' or $wtUstawieniaStrony['galleria']['przycinanie'] == 'landscape' or $wtUstawieniaStrony['galleria']['przycinanie'] == 'portrait') ? '1' : 'undefined' ?>,
		showCounter   : <?php echo ($wtUstawieniaStrony['licznik']) ? 'true' : 'false' ?>,
		pauseOnInteraction: <?php echo ($wtUstawieniaStrony['galleria']['pokazSlajdowInterakcja']) ? 'true' : 'false' ?>,
	   	transitionSpeed: 650, debug: false
	});
	Galleria.run('.wtGaleriaZdjec');
<?php } else { ?>
	lbCounter = <?php echo ($wtUstawieniaStrony['licznik']) ? 'true' : 'false' ?>;
<?php } ?>
</script>

<?php

}